"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _web = _interopRequireDefault(require("web3"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var resolveWeb3 = function resolveWeb3(resolve) {
  var _window = window,
      web3 = _window.web3;
  var alreadyInjected = typeof web3 !== "undefined"; // i.e. Mist/Metamask

  var localProvider = "http://localhost:9545";

  if (alreadyInjected) {
    console.log("Injected web3 detected.");
    web3 = new _web.default(web3.currentProvider);
  } else {
    console.log("No web3 instance injected, using Local web3.");
    var provider = new _web.default.providers.HttpProvider(localProvider);
    web3 = new _web.default(provider);
  }

  resolve(web3);
};

var _default = function _default() {
  return new Promise(function (resolve) {
    // Wait for loading completion to avoid race conditions with web3 injection timing.
    window.addEventListener("load", function () {
      resolveWeb3(resolve);
    }); // If document has loaded already, try to get Web3 immediately.

    if (document.readyState === "complete") {
      resolveWeb3(resolve);
    }
  });
};

exports.default = _default;